local health = 0.5
local length = 832
local rev = GAMESTATE:PlayerIsUsingModifier( pn, "reverse" ) and 1 or -1

return  Def.ActorFrame{
	Def.Sprite {
		Texture="_side";
		InitCommand=function(self)
			self:halign(0):y(-292)
		end;
	};
	Def.Quad {
		InitCommand=function(self)
		self:zoomto(27,length*rev):align(0.5,1):halign(0)
		self:y(-416)
		self:diffuse(1,0,0,1)
		self:bounce():effectclock("beat"):effecttiming(0,0.5,0.5,0,0):effectmagnitude(0,-55*rev,0)
		self:MaskSource()
		end;
		LifeChangedMessageCommand=function(self)
		--local newhealth = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentLife() --have issue in 0.71.1
		local newhealth = SCREENMAN:GetTopScreen():GetLifeMeter():GetLife() or health
		self:stoptweening()
		self:y(-416-(rev*length*(newhealth-0.5)))
		health = newhealth
		end;
		PlayerFailedMessageCommand=function(self)
		self:stopeffect():y(-416+(length*0.5))
		end
	};
	Def.Sprite {
		Texture="_life";
		Frames=Sprite.LinearFrames(2,1/15);
		InitCommand=function(self)
		length = self:GetZoomedHeight()+5
			self:x(2):y(-416):pause():setstate(0):halign(0)
			self:MaskDest()
		end;
		LifeChangedMessageCommand=function(self)
		local newhealth = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentLife()
			if newhealth >= 0.98 then
				self:play():setstate(1)
			else
				self:pause():setstate(0)
			end
		end
	};
	Def.Sprite {
		Texture="_glow_s";
		InitCommand=function(self)
			self:xy(13,16):blend('BlendMode_Add')
			self:diffuseramp():effectclock("beat"):effectcolor1(1,1,1,0):effectcolor2(1,1,1,1)
		end
	};
}