local health = 0.5
local length = 785
return  Def.ActorFrame{
	Def.Sprite {
		Texture="_life_base";
		InitCommand=function(self)
			self:y(-370)
		end;
	};
	Def.Quad {
		InitCommand=function(self)
		self:zoomto(27,length):align(0.5,1)
		self:y(-390)
		self:diffuse(1,0,0,1)
		self:bounce():effectclock("beat"):effecttiming(0,0.5,0.5,0,0):effectmagnitude(0,-55,0)
		self:MaskSource()
		end;
		LifeChangedMessageCommand=function(self)
		--local newhealth = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentLife() --have issue in 0.71.1
		local newhealth = SCREENMAN:GetTopScreen():GetLifeMeter():GetLife() or health
		self:stoptweening()
		self:y(-390-(length*(newhealth-0.5)))
		health = newhealth
		end;
		PlayerFailedMessageCommand=function(self)
		self:stopeffect():y(-390+(length*0.5))
		end
	};
	Def.Sprite {
		Texture="_life_main";
		InitCommand=function(self)
		length = self:GetZoomedHeight()
			self:y(-390)
			self:MaskDest()
		end;
	};
	Def.Sprite {
		Texture="_life_glow";
		InitCommand=function(self)
		self:y(-390)
		self:diffuseshift():effectperiod(1/15):effectcolor1(1,1,1,1):effectcolor2(1,1,1,0):diffusealpha(0)
		end;
		LifeChangedMessageCommand=function(self)
		local newhealth = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentLife()
			if newhealth >= 0.98 then
				self:diffusealpha(1)
			else
				self:diffusealpha(0)
			end
		end
	};
}