local Nskin = ... or {};        

	Nskin.ButtonRedir =
	{
		--dance
		Left = "White",
		UpLeft = "Blue",
		Down = "Blue",
		Up = "Blue", 
		UpRight = "Blue",
		Right = "White",
		--kb7
		Key1 = "White",
		Key2 = "Blue",
		Key3 = "White",
		Key4 = "Special",
		Key5 = "White",
		Key6 = "Blue",
		Key7 = "White"
	};
local OldRedir = Nskin.Redir;
Nskin.Redir = function(sButton, sElement)	
	if sElement == "Tap Fake" then
		sElement = "Tap Note";
	end	  
	if string.find(sElement,"Head") then
		sElement = "Hold Head";
	end
	if sElement == "Hold Body Inactive" or  sElement == "Hold Body Active" then
		sElement = "Hold Body";
	end
	if sElement == "Hold Topcap Inactive" or  sElement == "Hold Topcap Active" then
		sElement = "Hold Topcap";
	end
	if sElement == "Hold Bottomcap Inactive" or  sElement == "Hold Bottomcap Active" then
		sElement = "Hold Bottomcap";
	end	  
	if sElement == "Roll Body Inactive" or  sElement == "Roll Body Active" then
		sElement = "Roll Body";
	end
	if sElement == "Roll Topcap Inactive" or  sElement == "Roll Topcap Active" then
		sElement = "Roll Topcap";
	end
	if sElement == "Roll Bottomcap Inactive" or  sElement == "Roll Bottomcap Active" then
		sElement = "Roll Bottomcap";
	end
	--switch keys in solo and double
	sButton = Nskin.ButtonRedir[sButton];
	if GAMESTATE:GetCurrentStyle():GetStepsType() == "StepsType_Dance_Solo"  then
		if	Var "Button" == "Up" or Var "Button" == "Down" then 
			sButton = "White"; 
		end
	end
	if GAMESTATE:GetCurrentStyle():GetStepsType()  == "StepsType_Dance_Double" then
		if Var("Controller") == "GameController_1" then
			if Var "Button" == "Left" then
				sButton = "Special"
			elseif Var"Button" == "Down" or Var"Button" == "Right" then
				sButton = "White"
			elseif Var"Button" == "Up" then
				sButton = "Blue"
			end
		else
			if Var "Button" == "Right" then
				sButton = "Special"
			elseif Var"Button" == "Left" or Var"Button" == "Up" then
				sButton = "White"
			elseif Var"Button" == "Down" then
				sButton = "Blue"
			end
		end
	end





	return sButton, sElement;
end
local OldFunc = Nskin.Load;
function Nskin.Load()
	local t = OldFunc();
	local sElement = Var "Element";
	local sButton = Var "Button";
	local pn = Var"Player"
	local rev = GAMESTATE:PlayerIsUsingModifier( pn, "reverse" ) and 1 or -1
	local tilt = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions():Tilt()
	local mini = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions():Mini()
	if Var "Element" == "Ovceptor"  then
	--fix explosion's rotation caused by perspective tilt
	--measured 311.531% tilt = 90°; so 100% tilt should be about 28.89°
		t.BaseRotationX = -28.89*rev*tilt;
	--auto adjust explosion's size
		t.BaseZoomX = 1/(1-(mini/5.5))
		t.BaseZoomY = rev/(1-(mini/5.5))
	end	
	--flip receptor
	if Var "Element" == "Hold Explosion" or Var "Element" == "Receptor" then
		t.BaseZoomY = rev
	end
	return t;
end
Nskin.Rotate ={}
Nskin.PartsToRotate ={};
Nskin.Blank ={
	["Hold Tail Active"] = true,
	["Hold Tail Inactive"] = true,
	["Roll Head Active"] = true,
	["Roll Head Inactive"] = true,
	["Roll Tail Active"] = true,
	["Roll Tail Inactive"] = true,
	["Tap Explosion Dim"] = true,
	["Tap Sparkle"] = true,
	["Tap Explosion Bright"] = true,
	["Roll Explosion"] = true,
	["Ovceptor"] = false,	
};


return Nskin;
