--background process
local sButton = Var "Button"
local st = GAMESTATE:GetCurrentStyle():GetStepsType() 
local NoteWidth = 64
if st == "StepsType_Dance_Single"	 then
	NoteWidth = 62
elseif st == "StepsType_Dance_Solo" then
	NoteWidth = 41
elseif st == "StepsType_Kb7_Single" then
	NoteWidth=39
elseif st == "StepsType_Dance_Double" then
	NoteWidth=34
end
local LaneWidth = 256
if st == "StepsType_Kb7_Single" then
	LaneWidth = 273
elseif st == "StepsType_Dance_Double" then
	LaneWidth = 278
end
local getc	
local NfBoard
local rev = GAMESTATE:PlayerIsUsingModifier( pn, "reverse" ) and 1 or -1
local fitscreen = NOTESKIN:GetMetric("NoteskinPreferences","ForceFitScreen")
local curGear = NOTESKIN:GetMetric("NoteskinPreferences","Gear")

local t = Def.ActorFrame{
	Def.Quad {
		InitCommand=function(self)
			self:vertalign('VertAlign_Bottom'):horizalign('HorizAlign_Left'):blend('BlendMode_Add'):fadetop(1)
			self:xy(-NoteWidth/2,30)
			if curGear == "HX Standard" then
				self:diffuse(0,.9,1,0.3):zoomtoheight(143)
			elseif curGear == "HX1211" then
				self:diffuse(0,1,0.94,0.2):zoomtoheight(374)
			else
				self:visible(false)
			end
			if st == "StepsType_Kb7_Single" then
				self:zoomtowidth(273)
			elseif st == "StepsType_Dance_Double" then
				self:zoomtowidth(278)
			else
				self:zoomtowidth(256)
			end
		end		
	};
	-- wait for Rebirth to finish its adjustment to avoid conflict
	OnCommand=function(self)
		if string.find(SCREENMAN:GetTopScreen():GetName(),"Gameplay") then
			self:sleep(0.01):queuecommand("Begin")
		end
	end,
	-- start doing our trick
	BeginCommand=function(self)
			getc = SCREENMAN:GetTopScreen():GetChild("PlayerP1"):GetChild("NoteField"):get_column_actors()
	 		NfBoard= SCREENMAN:GetTopScreen():GetChild("PlayerP1"):GetChild("NoteField"):GetChild("Board")
			if  fitscreen == "on" then
				SCREENMAN:GetTopScreen():GetChild("PlayerP1"):GetChild("NoteField"):y(-55.5*rev):zoom(1)
				GAMESTATE:ApplyStageModifiers(pn,"57.6388% mini")
			end
			local mini = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions():Mini()
			--hide existing lifebar when using gears
			if curGear ~= "none" then
				SCREENMAN:GetTopScreen():GetLifeMeter(PLAYER_1):visible(false)
			end
			--adjust the location of each columns
			if st == "StepsType_Dance_Single"	 then
					getc[1]:x(-1)
					getc[2]:x(-3)
					getc[3]:x(3)
					getc[4]:x(1)
			elseif st == "StepsType_Dance_Solo"	 then
					NfBoard:zoomx(2/3)
					getc[1]:x(52.5)
					getc[2]:x(29.5)
					getc[3]:x(6.5)
					getc[4]:x(-6.5)
					getc[5]:x(-29.5)
					getc[6]:x(-52.5)
			elseif st == "StepsType_Kb7_Single"	 then
					NfBoard:zoomx(39/64)
					getc[1]:x(192-(192*39/64))
					getc[2]:x(128-(128*39/64))
					getc[3]:x(64-(64*39/64))
					getc[4]:x(0)
					getc[5]:x((64-(64*39/64))*-1)
					getc[6]:x((128-(128*39/64))*-1)
					getc[7]:x((192-(192*39/64))*-1)
			elseif st == "StepsType_Dance_Double"	 then
					NfBoard:zoomx(278/512)
					getc[1]:x(102)
					getc[2]:x(72)
					getc[3]:x(42)
					getc[4]:x(12)
					getc[5]:x(-12)
					getc[6]:x(-42)
					getc[7]:x(-72)
					getc[8]:x(-102)
			end
			--fix lanecover's width
			if playerConfig:get_data(pn_to_profile_slot(PLAYER_1)).LaneCover ~= 0 then --overlay method
				if SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("WifePerch") ~= nil  then
					local lanecover = SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("WifePerch"):GetChild(""):GetChild("CoverP1") or SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("WifePerch"):GetChild("")[1]:GetChild("CoverP1")
		 			lanecover:zoomtowidth(LaneWidth*(1-(mini/2)))
		 			local playerposition = SCREENMAN:GetTopScreen():GetChild("PlayerP1"):GetX() - SCREEN_CENTER_X
		 			lanecover:GetParent():x(playerposition)
		 		end
			elseif playerConfig:get_data().LaneCover ~= 0 then --notefield cover method
				local lc = SCREENMAN:GetTopScreen():GetChild("PlayerP1"):GetChild("NoteField"):GetChild("Cover"):GetChild("CoverP1") 
				lc:zoomtowidth(256)
			end
	end;
};
return t


