local sButton = Var "Button"
local cntrl = Var("Controller")
local st = GAMESTATE:GetCurrentStyle():GetStepsType() 
local curGear = NOTESKIN:GetMetric("NoteskinPreferences","Gear")
local NoteWidth = 64 
if st == "StepsType_Dance_Single"	 then
	NoteWidth = 62
elseif st == "StepsType_Dance_Solo" then
	NoteWidth = 41
elseif st == "StepsType_Kb7_Single" then
	NoteWidth=39
elseif st == "StepsType_Dance_Double" then
	NoteWidth=34
end
t = Def.ActorFrame{	
	--broadcast commands
	W1Command=function(self)
		MESSAGEMAN:Broadcast("ExplosionClick",{key=sButton,cntrl=cntrl})
	end;
	W2Command=function(self)
		MESSAGEMAN:Broadcast("ExplosionClick",{key=sButton,cntrl=cntrl})
	end;
	W3Command=function(self)
		MESSAGEMAN:Broadcast("ExplosionClick",{key=sButton,cntrl=cntrl})
	end;
	HeldCommand=function(self)
		MESSAGEMAN:Broadcast("ExplosionClick",{key=sButton,cntrl=cntrl})
	end;
	HoldingOnCommand=function(self)
		MESSAGEMAN:Broadcast("ExplosionHoldingOn",{key=sButton,cntrl=cntrl})
	end;
	HoldingOffCommand=function(self)
		MESSAGEMAN:Broadcast("ExplosionHoldingOff",{key=sButton,cntrl=cntrl})
	end;
	RollOnCommand=function(self)
		MESSAGEMAN:Broadcast("ExplosionHoldingOn",{key=sButton,cntrl=cntrl})
	end;
	RollOffCommand=function(self)
		MESSAGEMAN:Broadcast("ExplosionHoldingOff",{key=sButton,cntrl=cntrl})
	end;
}
if sButton == "Key1" or (sButton == "Left" and  not (st ==  "StepsType_Dance_Double" and cntrl == "GameController_2")) then
	t[#t+1] = LoadActor ("Gears/" .. tostring(curGear) .. "/stage")..{
		Name="Stage";
		InitCommand=function(self)
			self:y(30):zoom(128/205)
			self:x(-1*NoteWidth/2)
			if  st == "StepsType_Kb7_Single"	 then
				self:zoomx(273/410)
			end
			if  st == "StepsType_Dance_Double"	 then
				self:zoomx(278/410)
			end
		end;
	};
end
t[#t+1] = LoadActor ("Gears/"..curGear.."/key")

return t