local sButton = Var "Button"
local cntrl = Var("Controller")
local pn = Var"Player"
local rev = GAMESTATE:PlayerIsUsingModifier( pn, "reverse" ) and 1 or -1
local fakeCombo = NOTESKIN:GetMetric("NoteskinPreferences","UseOwnCombo")
local curGear = NOTESKIN:GetMetric("NoteskinPreferences","Gear")
local st = GAMESTATE:GetCurrentStyle():GetStepsType() 
-- ovceptor doesn't follow the column-actor's position change at current version etterna (0.70.3), I think it's a bug. maybe one day it will be fixed.
local xoffset = 0
			if st == "StepsType_Dance_Single"	 then
				if sButton == "Left" then
					xoffset=-1
				elseif sButton == "Down" then
					xoffset=-3
				elseif sButton == "Up" then
					xoffset=3
				elseif sButton == "Right" then
					xoffset=1
				end
			elseif st == "StepsType_Dance_Solo"	 then
				if sButton ==  "Left" then
					xoffset=52.5
				elseif sButton == "UpLeft" then
					xoffset=29.5
				elseif sButton == "Down" then
					xoffset=6.5
				elseif sButton == "Up" then
					xoffset=-6.5
				elseif sButton == "UpRight" then
					xoffset=-29.5
				elseif sButton == "Right" then
					xoffset=-52.5
				end
			elseif st == "StepsType_Kb7_Single"	 then
				if sButton == "Key1" then
					xoffset=192-(192*39/64)
				elseif sButton == "Key2" then
					xoffset=128-(128*39/64)
				elseif sButton == "Key3" then
					xoffset=64-(64*39/64)
				elseif sButton == "Key4" then
					xoffset=0
				elseif sButton == "Key5" then
					xoffset=(64-(64*39/64))*-1
				elseif sButton == "Key6" then
					xoffset=(128-(128*39/64))*-1
				elseif sButton == "Key7" then
					xoffset=(192-(192*39/64))*-1
				end
			elseif st == "StepsType_Dance_Double"	 then
				if cntrl == "GameController_1" then
					if sButton == "Left" then
						xoffset=102
					elseif sButton == "Down" then
						xoffset=72
					elseif sButton == "Up" then
						xoffset=42
					elseif sButton == "Right" then
						xoffset=12
					end
				else
					if sButton == "Left" then
						xoffset=-12
					elseif sButton == "Down" then
						xoffset=-42
					elseif sButton == "Up" then
						xoffset=-72
					elseif sButton == "Right" then
						xoffset=-102
					end
				end
			end
local t = Def.ActorFrame{
	Def.Sprite {
		Texture="Notes/" .. NOTESKIN:GetMetric("NoteskinPreferences","NoteType").."/_bomb";
		Frames = Sprite.LinearFrames(20,1/3);
		InitCommand=function(self)
			self:stoptweening():blend('BlendMode_Add'):loop(0):zoom(1.45):diffusealpha(0)
			self:x(xoffset)
		end;
		ExplosionClickMessageCommand=function(self,params)
		if params.key == sButton and params.cntrl == cntrl then
			self:stoptweening():diffusealpha(1):setstate(0):sleep(0.333):diffusealpha(0)
		end
		end;
		ExplosionHoldingOnMessageCommand=function(self,params)
		if params.key == sButton and params.cntrl == cntrl then
			self:stoptweening():diffusealpha(0)
		end
		end
	};	
	Def.Sprite {
		Texture="Notes/" .. NOTESKIN:GetMetric("NoteskinPreferences","NoteType").."/_bomb";
		Frames = Sprite.LinearFrames(4,1/8);
		InitCommand=function(self)
			self:stoptweening():blend('BlendMode_Add'):loop(1):zoom(1.45):diffusealpha(0)
			self:x(xoffset)
		end;
		ExplosionHoldingOnMessageCommand=function(self,params)
		if params.key == sButton and params.cntrl == cntrl then
			self:stoptweening():diffusealpha(1)
		end
		end;
		ExplosionHoldingOffMessageCommand=function(self,params)
		if params.key == sButton and params.cntrl == cntrl then
			self:stoptweening():diffusealpha(0)
		end
		end;
	};
	Def.Sprite {
		Texture="Notes/" .. NOTESKIN:GetMetric("NoteskinPreferences","NoteType").."/_hold exp";
		Frames = Sprite.LinearFrames(4,1/6);
		InitCommand=function(self)
			self:stoptweening():blend('BlendMode_Add'):loop(1):zoom(1.45):diffusealpha(0)
			self:x(xoffset)
		end;
		ExplosionHoldingOnMessageCommand=function(self,params)
		if params.key == sButton and params.cntrl == cntrl then
			self:stoptweening():diffusealpha(1)
		end
		end;
		ExplosionHoldingOffMessageCommand=function(self,params)
		if params.key == sButton and params.cntrl == cntrl then
			self:stoptweening():diffusealpha(0)
		end
		end;
	}
}

-- fake combo
local numKeys 
if st == "StepsType_Dance_Single"	 then
	numKeys = 4
elseif st == "StepsType_Dance_Solo" then
	numKeys = 6
elseif st == "StepsType_Kb7_Single" then
	numKeys= 7
elseif st == "StepsType_Dance_Double" then
	numKeys= 8
end
if sButton == "Key1" or (sButton == "Left" and  not (st ==  "StepsType_Dance_Double" and cntrl == "GameController_2")) then
	if fakeCombo == "on" then
		t[#t+1] = LoadActor("Gears/" .. tostring(curGear) .. "/combo")..{
			OnCommand=function(self)
				self:x(numKeys*64/2-32)
				self:y(-365+(20*(1-rev))):zoomx(0.62):zoomy(0.62*rev)
			end
		}
	end
end


return t