local sButton = Var "Button"
local cntrl = Var("Controller")
local st = GAMESTATE:GetCurrentStyle():GetStepsType() 
local NoteWidth = 64
local Laser = NOTESKIN:GetMetric("NoteskinPreferences","Laser")
local Gear = NOTESKIN:GetMetric("NoteskinPreferences","Gear")
local bob = NOTESKIN:GetMetric("NoteskinPreferences","ReceptorIsBob")
local receptorZoom = 1
if st == "StepsType_Dance_Single"	 then
	NoteWidth = 62
elseif st == "StepsType_Dance_Solo" then
	NoteWidth = 41
elseif st == "StepsType_Kb7_Single" then
	NoteWidth=39
elseif st == "StepsType_Dance_Double" then
	NoteWidth=34
end
local keys = string.find(",Key2,Key6,Up,Down,UpRight,UpLeft," ,","..sButton..",") and 2 or 1
if sButton == "Key4" then
	keys=3
end
if GAMESTATE:GetCurrentStyle():GetStepsType() == "StepsType_Dance_Solo"  then
	if string.find(",Up,Down,",","..sButton..",") then
		keys=1
	end
end
if GAMESTATE:GetCurrentStyle():GetStepsType() == "StepsType_Dance_Double"  then
		if Var("Controller") == "GameController_1" then
			if sButton == "Left" then
				keys=3
			elseif sButton == "Down" or sButton == "Right" then
				keys=1
			elseif sButton == "Up" then
				keys=2
			end
		else
			if sButton == "Right" then
				keys=3
			elseif sButton == "Left" or sButton == "Up" then
				keys=1
			elseif sButton == "Down" then
				keys=2
			end
		end
end

local t = Def.ActorFrame{
	
	--broadcast commands
	PressCommand=function(self)
		MESSAGEMAN:Broadcast("ButtonPressed",{key=sButton,cntrl=cntrl})
	end;
	LiftCommand=function(self)
		MESSAGEMAN:Broadcast("ButtonLifted",{key=sButton,cntrl=cntrl})
	end;

	--laser
	Def.Quad {
		InitCommand=function(self)
			if Laser == "off" then
				self:visible(false)
			end
			self:align(0.5,1):y(30):zoomto(NoteWidth,0):fadetop(0.65)
			if Gear == "none" then
				self:fadebottom(0.1):align(0.5,0.9)
			end
			if keys == 2 then
				self:diffuse(0.5,0,1,0.5)
			elseif keys == 3 then
				self:diffuse(0,1,0,0.4)
			else
				self:diffuse(1,0,0.25,0.4)
			end
		end;
		PressCommand=function(self)
			self:finishtweening():linear(0.01):zoomtoheight(420):sleep(0.04)
		end;
		LiftCommand=function(self)
			self:linear(0.03):zoomtoheight(0)
		end
	};
	--receptor
	Def.Sprite {
		Texture="Notes/" .. NOTESKIN:GetMetric("NoteskinPreferences","NoteType") .."/_receptor";
		InitCommand=function(self)
		if bob == "on" then
			self:bob():effectmagnitude(0,0.44,0):effectperiod(1)
		end
		if Gear == "none" then
			self:glowramp():effectcolor1(1,1,1,-0.8):effectcolor2(1,1,1,.3):effectclock("beat")
		end
		if st =="StepsType_Kb7_Single" or st == "StepsType_Dance_Double" then
			receptorZoom = 0.925
			self:zoom(receptorZoom)
		end
		end;
		NoneCommand=function(self)
		if Laser == "off" and Gear == "none" then
			self:zoom(0.75*receptorZoom):linear(0.1):zoom(1*receptorZoom)
		end
		end;
	};
};


if sButton == "Key1" or (sButton == "Left" and  not (st ==  "StepsType_Dance_Double" and cntrl == "GameController_2")) then
	t[#t+1] = LoadActor ("_bg")..{
		InitCommand=function(self)
			self:draworder(-10)
		end
	}
end



return t


