local notes = GAMESTATE:GetCurrentSteps(pn):GetRadarValues(pn):GetValue(0)
local progress = 0
local maxcombo = 0



local t = Def.ActorFrame{
	OnCommand=function(self)
	SCREENMAN:GetTopScreen():GetLifeMeter(PLAYER_1):visible(false)
	end;
	Def.Sprite {
		Texture="_bottom";
		InitCommand=function(self)
			self:vertalign('VertAlign_Top'):horizalign('HorizAlign_Left')
		end
	};
	Def.Sprite {
		Texture="_glow_b";
		InitCommand=function(self)
			self:vertalign('VertAlign_Top'):horizalign('HorizAlign_Left'):blend('BlendMode_Add')
			self:diffuseramp():effectclock("beat"):effectcolor1(1,1,1,0):effectcolor2(1,1,1,1)
		end
	};
	LoadActor("side")..{
		InitCommand=function(self)
			self:xy(410,0):zoom(1)
		end
	};
	LoadActor("side")..{
		InitCommand=function(self)
			self:xy(0,0):zoomx(-1)
		end
	};

	Def.BitmapText{
    	File=NOTESKIN:GetPath("","Gears/DarkConcert/number.ini");
		InitCommand = function(self)
			self:xy(205,160)
			self:settextf("%07d", 0)
		end;
		JudgmentMessageCommand=function (self,msg)
			if msg.Judgment == "TapNoteScore_W1" then
				progress = progress + 1
			elseif msg.Judgment == "TapNoteScore_W2" then
				progress = progress + 0.7
			elseif msg.Judgment == "TapNoteScore_W3" then
				progress = progress + 0.2
		end
		self:settextf("%07d",progress/notes*1100000)
		end;		
	};
	Def.BitmapText{
    	File=NOTESKIN:GetPath("","Gears/DarkConcert/number.ini");
		InitCommand = function(self)
			self:xy(205,212)
			self:settextf("%05d", 0)
		end;
		ComboChangedMessageCommand=function (self,msg)
			local CurCombo = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentCombo()
			if CurCombo > maxcombo then
				maxcombo = CurCombo
			end
			self:settextf("%05d", maxcombo)
		end
	}

};

return t