local notes = GAMESTATE:GetCurrentSteps(pn):GetRadarValues(pn):GetValue(0)
local progress = 0
local maxcombo = 0



local t = Def.ActorFrame{
	OnCommand=function(self)
	SCREENMAN:GetTopScreen():GetLifeMeter(PLAYER_1):visible(false)
	end;
	Def.Sprite {
		Texture="_bottom";
		InitCommand=function(self)
			self:vertalign('VertAlign_Top'):horizalign('HorizAlign_Left')
		end
	};
	Def.Sprite {
		Texture="_left";
		InitCommand=function(self)
			self:vertalign('VertAlign_Bottom'):horizalign('HorizAlign_Right'):y(247)
		end
	};
	Def.Sprite {
		Texture="_right";
		InitCommand=function(self)
			self:vertalign('VertAlign_Bottom'):horizalign('HorizAlign_Left'):xy(410,247)
		end
	};
	Def.Sprite {
		Texture="_butterfly";
		InitCommand=function(self)
			self:vertalign('VertAlign_Bottom'):horizalign('HorizAlign_Left'):xy(427,247)
		end
	};
	Def.Sprite {
		Texture="_butterfly";
		InitCommand=function(self)
			self:vertalign('VertAlign_Bottom'):horizalign('HorizAlign_Left'):xy(427,247)
			self:blend('BlendMode_Add'):diffuseramp():effectcolor2(0,0,0,0.6):effectcolor1(4,4,4,0):effectclock("beat"):effecttiming(0.2,0,0.4,0,0.4)
		end
	};
	LoadActor("LifeBar")..{
		InitCommand=function(self)
	local rev = GAMESTATE:PlayerIsUsingModifier( pn, "reverse" ) and 1 or -1
			self:xy(435.5,-(1-rev)*417):zoomy(rev)
		end
	};
	Def.BitmapText{
    	File=NOTESKIN:GetPath("","Gears/HX Standard/number.ini");
		InitCommand = function(self)
			self:xy(123,144)
			self:settextf("%07d", 0)
		end;
		JudgmentMessageCommand=function (self,msg)
			if msg.Judgment == "TapNoteScore_W1" then
				progress = progress + 1
			elseif msg.Judgment == "TapNoteScore_W2" then
				progress = progress + 0.7
			elseif msg.Judgment == "TapNoteScore_W3" then
				progress = progress + 0.2
		end
		self:settextf("%07d",progress/notes*1100000)
		end;		
	};
	Def.BitmapText{
    	File=NOTESKIN:GetPath("","Gears/HX Standard/number.ini");
		InitCommand = function(self)
			self:xy(328,144)
			self:settextf("%05d", 0)
		end;
		ComboChangedMessageCommand=function (self,msg)
			local CurCombo = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentCombo()
			if CurCombo > maxcombo then
				maxcombo = CurCombo
			end
			self:settextf("%05d", maxcombo)
		end
	}

};

return t