local notes = GAMESTATE:GetCurrentSteps(pn):GetRadarValues(pn):GetValue(0)
local progress = 0
local maxcombo = 0



local t = Def.ActorFrame{
	OnCommand=function(self)
	SCREENMAN:GetTopScreen():GetLifeMeter(PLAYER_1):visible(false)
	end;
	Def.Sprite {
		Texture="_bottom";
		InitCommand=function(self)
			self:vertalign('VertAlign_Top'):horizalign('HorizAlign_Left'):x(-125)
		end
	};
	Def.Sprite {
		Texture="_glow";
		InitCommand=function(self)
			self:vertalign('VertAlign_Top'):horizalign('HorizAlign_Left'):x(-125)
			self:diffuseramp():effectclock("beat"):effectcolor1(1,1,1,0):effectcolor2(1,1,1,1)
		end
	};
	Def.Sprite {
		Texture="_left";
		InitCommand=function(self)
			self:vertalign('VertAlign_Bottom'):horizalign('HorizAlign_Right')
		end
	};
	Def.Sprite {
		Texture="_right";
		InitCommand=function(self)
			self:vertalign('VertAlign_Bottom'):horizalign('HorizAlign_Left'):x(410)
		end
	};
	LoadActor("LifeBar")..{
		InitCommand=function(self)
	local rev = GAMESTATE:PlayerIsUsingModifier( pn, "reverse" ) and 1 or -1
			self:xy(429.5,-(1-rev)*370):zoomy(rev)
		end
	};

	Def.BitmapText{
    	File=NOTESKIN:GetPath("","Gears/HX1211/number.ini");
		InitCommand = function(self)
			self:xy(137,150):diffusealpha(0.95)
			self:settextf("%07d", 0)
		end;
		JudgmentMessageCommand=function (self,msg)
			if msg.Judgment == "TapNoteScore_W1" then
				progress = progress + 1
			elseif msg.Judgment == "TapNoteScore_W2" then
				progress = progress + 0.7
			elseif msg.Judgment == "TapNoteScore_W3" then
				progress = progress + 0.2
		end
		self:settextf("%07d",progress/notes*1100000)
		end;		
	};
	Def.BitmapText{
    	File=NOTESKIN:GetPath("","Gears/HX1211/number.ini");
		InitCommand = function(self)
			self:xy(261,150):zoom(0.7):diffusealpha(0.95)
			self:settextf("%05d", 0)
		end;
		ComboChangedMessageCommand=function (self,msg)
			local CurCombo = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentCombo()
			if CurCombo > maxcombo then
				maxcombo = CurCombo
			end
			self:settextf("%05d", maxcombo)
		end
	}

};

return t